#ifndef FOCUSEDCOLUMNMODULE__H
#define FOCUSEDCOLUMNMODULE__H

#include <torch/torch.h>
#include "Submodule.hpp"
#include "MyModule.hpp"
#include "LSTM.hpp"
#include "GRU.hpp"

class FocusedColumnModuleImpl : public Submodule
{
  private :

  torch::nn::Embedding wordEmbeddings{nullptr};
  std::shared_ptr<MyModule> myModule{nullptr};
  std::vector<int> focusedBuffer, focusedStack;
  std::string column;
  int maxNbElements;
  int inSize;

  public :

  FocusedColumnModuleImpl(const std::string & definition);
  torch::Tensor forward(torch::Tensor input);
  std::size_t getOutputSize() override;
  std::size_t getInputSize() override;
  void addToContext(std::vector<std::vector<long>> & context, Dict & dict, const Config & config) const override;
  void registerEmbeddings(std::size_t nbElements) override;
};
TORCH_MODULE(FocusedColumnModule);

#endif

