#ifndef MODULARNETWORK__H
#define MODULARNETWORK__H

#include "NeuralNetwork.hpp"
#include "ContextModule.hpp"
#include "RawInputModule.hpp"
#include "SplitTransModule.hpp"
#include "FocusedColumnModule.hpp"
#include "DepthLayerTreeEmbeddingModule.hpp"
#include "StateNameModule.hpp"
#include "MLP.hpp"

class ModularNetworkImpl : public NeuralNetworkImpl
{
  private :

  torch::nn::Dropout inputDropout{nullptr};

  MLP mlp{nullptr};
  std::vector<std::shared_ptr<Submodule>> modules;
  std::map<std::string,torch::nn::Linear> outputLayersPerState;

  public :

  ModularNetworkImpl(std::map<std::string,std::size_t> nbOutputsPerState, std::vector<std::string> definitions);
  torch::Tensor forward(torch::Tensor input) override;
  std::vector<std::vector<long>> extractContext(Config & config, Dict & dict) const override;
  void registerEmbeddings(std::size_t nbElements) override;
};

#endif
